from ucfg_utils import *
from ucfg_idb import IDBConfigUtilities

from ucfg_configurator import UConfiguratorBase

#TODO - implement me
class UConfigurator(UConfiguratorBase):
	__idb_params = {
			'uxTotalCPUsMin'			: '1',
			'uxTotalCPUsMax' 			: '1',
			'uxTotalCPUsDefault' 		: None,

			'uxNodesMin' 				: '1',
			'uxNodesMax' 				: '1',
			'uxNodesDefault' 			: '1',

			'uxCPUsPerNodeMin' 			: '1',
			'uxCPUsPerNodeMax' 			: '1',
			'uxCPUsPerNodeDefault' 		: '1',

			'uxTimeMin' 				: '10',
			'uxTimeMax' 				: '86000',
			'uxTimeDefault' 			: '3600',

			'uxMemoryPerNodeMin' 		: '1048576',
			'uxMemoryPerNodeMax' 		: '1073741824',
			'uxMemoryPerNodeDefault' 	: '268435456',
	}

	def getParams(self):
		return self.__idb_params

	def run(self, options, config, section, params):
		info(options, "IDB configurator (" + section + ")")
		idbCfgUtil = IDBConfigUtilities(options, 'unicorex')

		resourcesDict = {
			'TotalCPUCount' 			: [ params['uxTotalCPUsDefault'], params['uxTotalCPUsMin'], params['uxTotalCPUsMax'] ],
			'TotalResourceCount' 		: [ params['uxNodesDefault'], params['uxNodesMin'], params['uxNodesMax'] ],
			'IndividualCPUCount' 		: [ params['uxCPUsPerNodeDefault'], params['uxCPUsPerNodeMin'], params['uxCPUsPerNodeMax'] ],
			'IndividualCPUTime' 		: [ params['uxTimeDefault'], params['uxTimeMin'], params['uxTimeMax'] ],
			'IndividualPhysicalMemory' 	: [ params['uxMemoryPerNodeDefault'], params['uxMemoryPerNodeMin'], params['uxMemoryPerNodeMax'] ]
		}
		idbCfgUtil.setIDBResourcesLimits('simpleidb', resourcesDict)

		info(options, "Finished IDB (" + section + ")")

