from ucfg_configurator import *
from ucfg_utils import info
from ucfg_main import ConfigUtilities


class UConfigurator(UConfiguratorBase):
	__tsi_params = {
			'tsiHost' 				: 'localhost',
			'tsiPort'				: '4433',
			'tsiNJSPort' 			: '7654',

			'tsiInstallDirectory'	: '__REQUIRED',
			'tsiLogsDirectory'		: '__REQUIRED'
	}

	def getParams(self):
		return self.__tsi_params

	def run(self, options, config, section, params):
		info(options, "TSI configurator (" + section + ")")
		cfgUtil = ConfigUtilities(options, section)

		# tsi.properties
		cfgUtil.setJavaProperties('tsi.properties', {
			'tsi.path' 			: params['tsiInstallDirectory'] + '/perl',
			'tsi.njs_machine' 	: params['tsiHost'],
			'tsi.njs_port' 		: params['tsiNJSPort'],
			'tsi.my_port' 		: params['tsiPort'],
			'tsi.logdir' 		: params['tsiLogsDirectory']
		})

		info(options, "Finished TSI (" + section + ")")

