from ucfg_configurator import *
from ucfg_utils import info, getFile

from ucfg_main import ConfigUtilities


class UConfigurator(UConfiguratorBase):
	__uftpd_params = {
			'uftpHost' 				 : '__REQUIRED',
			'uftpPort'				 : '64434',
			'uftpMemory'			 : '128',

			'uftpACLEntry.0' 		 : '__REQUIRED',

			'uftpKeystorePath'       : 'conf/keystore.jks',
			'uftpKeystorePassword'   : 'the!njs',
			'uftpKeystoreType' 		 : 'JKS',
			'uftpKeystoreAlias' 	 : None,
			'uftpTruststorePath' 	 : 'conf/keystore.jks',
			'uftpTruststorePassword' : 'the!njs',
			'uftpTruststoreType' 	 : None
	}

	def getParams(self):
		return self.__uftpd_params

	def run(self, options, config, section, params):
		info(options, "UNICORE FTP Daemon configurator (" + section + ")")
		cfgUtil = ConfigUtilities(options, section)

		#uftpd-ssl.conf
		cfgUtil.setJavaProperties('uftpd-ssl.conf', {
			'javax.net.ssl.keyStore' 			: params['uftpKeystorePath'],
			'javax.net.ssl.keyStorePassword' 	: params['uftpKeystorePassword'],
			'javax.net.ssl.keyStoreType' 		: params['uftpKeystoreType'],
			'javax.net.ssl.trustStore' 			: params['uftpTruststorePath'],
			'javax.net.ssl.trustStorePassword' 	: params['uftpTruststorePassword'],
		})

		#uftpd.conf
		cfgUtil.setShellVariables('uftpd.conf', {
			'export SERVER_HOST' : params['uftpHost'],
			'export SERVER_PORT' : params['uftpPort'],
			'export UFTPD_MEM' 	 : params['uftpMemory']
		})

		#uftpd.acl
		cfgUtil.setShellVariables('uftpd.acl', { 'emailAddress' : None })
		uftpACLEntriesList = [ params['uftpACLEntry.0'] ]
		i = 1
		while 'uftpACLEntry.%d' % i in params.keys():
			uftpACLEntriesList = uftpACLEntriesList + [ params['uftpACLEntry.%d' % i] ]
			i = i + 1
		cfgUtil.appendLinesIfNotAlreadyExist('uftpd.acl', uftpACLEntriesList)

		info(options, "Finished UNICORE FTP Daemon (" + section + ")")

