from ucfg_utils import *
from ucfg_main import ConfigUtilities

from _use import USEConfigurator

#TODO - implement me - this is not updated fully!!!!
class UConfigurator(USEConfigurator):
	__ux_params = {
			'unicore.wsrflite.host'				: 'localhost##Host address on which container will listen',
			'unicore.wsrflite.port'				: '7777##Port on which container will listen',

			'uxSiteName'				: 'DEMO-SITE',
			'uxBaseUrl' 				: None,

			'uxXNJSConfigFile' 			: 'conf/xnjs.xml',
			'uxUseExternalRegistry' 	: 'false',
			'uxUrlExternalRegistry' 	: None,

			'uxEnableBES' 		 		: 'false',
			'uxDisableHomes' 			: None,
			'uxEnableGlobalStorage' 	: 'false',
			'uxGlobalStoragePath' 		: None,
			'uxEnableStorageFactory' 	: 'false',
			'uxDefaultStorageFactoryPath' : None,

			'uxTSIDirectory' 			: '__REQUIRED',
			'uxTSIHost' 				: 'localhost',
			'uxTSIPort' 				: '4433',
			'uxTSICallbackPort' 		: '7654',
			'uxTSIQstatUser' 			: 'unicore',
			'uxTSIStatusUpdateInterval' : '3000',
			'uxTSIUserSpacePath' 		: '__REQUIRED'
		}

	def __init__(self):
		super(UConfigurator, self).__init__()
		self.__my_params = super(UConfigurator, self).getParams().copy()
		self.__my_params.update(self.__ux_params)

	def getParams(self):
		return self.__my_params

	def run(self, options, config, section, params):
		info(options, "UNICORE/X configurator (" + section + ")")

		super(UConfigurator, self).run(options, config, section, params)

		cfgUtil = ConfigUtilities(options, section)


		# setting some variables for uas.config
		uxUrlExternalRegistry = params['uxUrlExternalRegistry']
		if uxUrlExternalRegistry == None:
			uxUrlExternalRegistry = 'https://' + params['gwHost'] + ':' + params['gwPort'] + '/' + params['regSiteName'] + '/services/Registry?res=default_registry'
		uasOnStartup = "de.fzj.unicore.uas.util.DefaultOnStartup"
		if params['uxEnableGlobalStorage'].lower() == 'true':
			uasOnStartup = uasOnStartup + " \\\nde.fzj.unicore.uas.util.CreateSMSOnStartup"
		if params['uxEnableBES'].lower() == 'true':
			uasOnStartup = uasOnStartup + " \\\nde.fzj.unicore.bes.util.BESOnStartup"
		''' @todo: design append operation to property '''

		# uas.config
		cfgUtil.setJavaProperties('uas.config', {
			'uas.targetsystemfactory.xnjs.configfile' : params['uxXNJSConfigFile'],
			'uas.targetsystem.sitename' : params['uxSiteName'],

			'uas.externalregistry.use' : params['uxUseExternalRegistry'],
			'uas.externalregistry.url' : uxUrlExternalRegistry,

			'uas.onstartup' : uasOnStartup,

			'uas.storagefactory.DEFAULT.path' : params['uxDefaultStorageFactoryPath'],
			'defaultsms.workdir' : params['uxGlobalStoragePath'],

			'uas.targetsystem.home.disable' : params['uxDisableHomes'],

			'bes.common.name' : 'BES-' + params['uxSiteName'],
			'bes.long.description' : 'BES Interface for ' + params['uxSiteName']
		})


		# wsrflite.xml
		uxBaseUrl = params['uxBaseUrl']
		if uxBaseUrl == None:
			uxBaseUrl = 'https://' + params['useHost'] + ':' + params['usePort'] + '/' + params['uxSiteName'] + '/services'
		cfgUtil.setWSRFLiteProperties('wsrflite.xml', {
			'unicore.wsrflite.baseurl' 	: uxBaseUrl,
		})
		cfgUtil.toggleWSRFLiteServices('wsrflite.xml', {
			'StorageFactory': params['uxEnableStorageFactory']
		})


		# xnjs configuration
		if params['uxXNJSConfigFile'].endswith('xnjs.xml'):
			# xnjs.xml
			cfgUtil.setXNJSProperties('xnjs.xml', {
				'XNJS.filespace' : params['uxTSIUserSpacePath']
			})
		else:
			# xnjs_legacy.xml
			cfgUtil.setXNJSProperties('xnjs_legacy.xml', {
				'XNJS.filespace' : params['uxTSIUserSpacePath'],

				'CLASSICTSI.machine' 	: params['uxTSIHost'],
				'CLASSICTSI.port' 		: params['uxTSIPort'],
				'CLASSICTSI.replyport' 	: params['uxTSICallbackPort'],
				'CLASSICTSI.priveduser' : params['uxTSIQstatUser'],
				'CLASSICTSI.statusupdate.interval' : params['uxTSIStatusUpdateInterval'],
				'CLASSICTSI.TSI_LS' : params['uxTSIDirectory'] + '/perl/tsi_ls',
				'CLASSICTSI.TSI_DF' : params['uxTSIDirectory'] + '/perl/tsi_df',
			})

		info(options, "Finished UNICORE/X (" + section + ")")

