package de.fzj.unicore.bes.faults;

import javax.xml.namespace.QName;

import org.apache.xmlbeans.XmlObject;
import org.codehaus.xfire.fault.FaultInfoException;

import de.fzj.unicore.bes.util.ActivityUtils;

public class XmlBeansFault extends FaultInfoException {
	
	private static final long serialVersionUID=1L;
	
	private XmlObject faultDetail;
	
	public XmlBeansFault(String message, Throwable cause, XmlObject details){
		super(message,cause);
		this.faultDetail=details;
	}
	
	//this one seems to be required by Xfire?!
	public XmlBeansFault(String message, XmlObject details){
		super(message);
		this.faultDetail=details;
	}

	public XmlBeansFault(String message){
		super(message);
	}
	
	public XmlObject getFaultInfo() {
		return faultDetail;
	}
	
	public static QName getFaultName() {
		return new QName("XmlBeansFault");
	}
	
	/**
	/* helper for creating a BaseFault including the mandatory timestamp
	*/
	
	public static XmlBeansFault createFault(String message){
		XmlObject o= XmlObject.Factory.newInstance();
		QName faultCode = new QName("bes",XmlBeansFault.class.getName());
		o.set(ActivityUtils.buildSOAP11Fault(faultCode, message));
		XmlBeansFault n = new XmlBeansFault(message, o);
		return n;
	}
	

	
	
}

