package de.fzj.unicore.uas.util;

import de.fzj.unicore.uas.fts.FileTransferCapabilities;
import de.fzj.unicore.uas.xnjs.U6FileTransferCreator;
import de.fzj.unicore.wsrflite.Capabilities;
import de.fzj.unicore.wsrflite.Capability;
import de.fzj.unicore.xnjs.io.IFileTransferCreator;
import de.fzj.unicore.xnjs.io.IOCapabilities;

/**
 * lists the capabilities provided by UAS core
 * 
 * @author schuller
 */
public class CoreCapabilities implements Capabilities, IOCapabilities{

	@Override
	public Capability[] getCapabilities() {
		return new Capability[]{
				FileTransferCapabilities.BFT,
				FileTransferCapabilities.RBYTEIO,
				FileTransferCapabilities.SBYTEIO,
		};
	}

	@Override
	@SuppressWarnings("unchecked")
	public Class<? extends IFileTransferCreator>[] getFileTransferCreators() {
		return new Class[]{
				U6FileTransferCreator.class,
		};
	}

	
	
}
